<?php
/*
Receive file posted via http.

Last change: 2008-05-11 (Frank Baettermann)
*/

define('SECRET', 'YOUR-SECRET');

// check secret
error_reporting(E_NONE);
if (!isset($_POST['secret']) || $_POST['secret'] != SECRET)
    exit; // die silently

// show errors after checking the scecret
error_reporting(E_ALL);
define('DIR_ROOT', dirname(__FILE__));

// directory creation fails if I use the built-in recursive function(???)
// found on php.net/manual/en/function.mkdir.php
function mkdir_recursive($pathname)
{
    is_dir(dirname($pathname)) || mkdir_recursive(dirname($pathname));
    return is_dir($pathname) || mkdir($pathname);
}

$action = (isset($_POST['action']) ? $_POST['action'] : 'upload');
$directory = (isset($_POST['directory']) ? trim($_POST['directory'], '/') : '');
$full_dir = DIR_ROOT.($directory != '' ? "/".$directory : '');
switch ($action)
{
    case 'upload':
        if (count($_FILES) != 1)
            die("Error: Did not receive any file (or more than one).");
        if (!is_writable(DIR_ROOT))
            die("Error: The directory \"".DIR_ROOT."\" is not writeable.");
        if (file_exists($directory) === false && mkdir_recursive($directory) !== true)
            die("Error: Failed to create directory \"$directory\".");
        if (move_uploaded_file($_FILES['file']['tmp_name'], $full_dir."/".$_FILES['file']['name']) === false)
            die("Error: Could not move uploaded file.");
        break;

    default:
        die("Error: Unknown action: $action");
}

// some kind of return-code in successful cases
echo "Ok"
?>